Make local testing dependent on $METAINIT_PREFIX
[darcs-mirror-metainit.git] / create-sysvinit-file
1 #!/usr/bin/perl -w
2 #
3 # Creates a sysvinit file from a metainit description.
4 #
5
6 use MetaInit::Parse;
7
8 $filename = shift || die "Filename expected!\n";
9 my $output = shift;
10
11 # Parse the metainit in
12 %initparams = %{MetaInit::Parse::parse($filename)};
13
14 if ($output) {
15         open(STDOUT,'>',$output) or die $!;
16 }
17
18 # Print the "dynamic" part of the initskript
19 print << "EOF"
20 #! /bin/sh
21 #
22 # This a generated file. DO NOT EDIT THIS FILE!
23 # If you want to modify who this file works, please
24 # modify $filename and re-run update-metainit.
25 #
26 # If you are sure that you want to modify this file,
27 # remove this comment, and update-metainit will not override
28 # this script any more.
29 #
30 ### BEGIN INIT INFO
31 # Provides:          $initparams{"Name"}
32 # Default-Start:     2 3 4 5
33 # Default-Stop:      0 1 6
34 # Short-Description: $initparams{"Desc"}
35 EOF
36 ;
37
38 print "# Required-Start:   " . join(" ",@{$initparams{"Required-Start"}}) . "\n";
39 print "# Required-Stop:     " . join(" ",@{$initparams{"Required-Stop"}}) . "\n";
40 print "# Description:       ";
41 print join("\n#                    ",split("\n",$initparams{"Description"})). "\n";
42 print "\n";
43
44 # prevent quoted strings from breaking the generated script:
45
46 my %quoted_initparams;
47
48 while (my ($k, $v) = each %initparams){
49         $quoted_initparams{$k} = quotemeta $v;
50 }
51
52 print << "EOF"
53 ### END INIT INFO
54
55 # WARNING:
56 # This initscript has been autogenerated by metainit.
57 # Do not edit this file, but edit the corresponding metainit
58 # config.
59
60 # PATH should only include /usr/* if it runs after the mountnfs.sh script
61 PATH=/sbin:/usr/sbin:/bin:/usr/bin
62 DESC=$quoted_initparams{"Desc"}
63 NAME=$quoted_initparams{"Name"}
64 DAEMON=$initparams{"Path"}
65 DAEMON_ARGS=$quoted_initparams{"Args"}
66 PIDFILE=/var/run/\$NAME.pid
67 SCRIPTNAME=/etc/init.d/\$NAME
68 EOF
69 ;
70
71 # ... and the rest of the initscript, that is identical for all
72 # metainit-created scripts.
73 print << 'EOF'
74 # Exit if the package is not installed
75 [ -x "$DAEMON" ] || exit 0
76
77 # Read configuration variable file if it is present
78 [ -r /etc/default/$NAME ] && . /etc/default/$NAME
79
80 # Load the VERBOSE setting and other rcS variables
81 . /lib/init/vars.sh
82
83 # Define LSB log_* functions.
84 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
85 . /lib/lsb/init-functions
86
87 #
88 # Function that starts the daemon/service
89 #
90 do_start()
91 {
92 EOF
93 ;
94
95 if($initparams{"Prestart-Hook"}) {
96     print "\t" . join("\n\t",split("\n",$initparams{"Prestart-Hook"}));
97     print "\n";
98 }
99
100 print << 'EOF'
101         # Return
102         #   0 if daemon has been started
103         #   1 if daemon was already running
104         #   2 if daemon could not be started
105         start-stop-daemon --start --background --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
106                 || return 1
107         start-stop-daemon --start --background --quiet --pidfile $PIDFILE --exec $DAEMON -- \
108                 $DAEMON_ARGS \
109                 || return 2
110         # Add code here, if necessary, that waits for the process to be ready
111         # to handle requests from services started subsequently which depend
112         # on this one.  As a last resort, sleep for some time.
113 }
114
115 #
116 # Function that stops the daemon/service
117 #
118 do_stop()
119 {
120         # Return
121         #   0 if daemon has been stopped
122         #   1 if daemon was already stopped
123         #   2 if daemon could not be stopped
124         #   other if a failure occurred
125         start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME
126         RETVAL="$?"
127         [ "$RETVAL" = 2 ] && return 2
128         # Wait for children to finish too if this is a daemon that forks
129         # and if the daemon is only ever run from this initscript.
130         # If the above conditions are not satisfied then add some other code
131         # that waits for the process to drop all resources that could be
132         # needed by services started subsequently.  A last resort is to
133         # sleep for some time.
134         start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
135         [ "$?" = 2 ] && return 2
136         # Many daemons don't delete their pidfiles when they exit.
137         rm -f $PIDFILE
138 EOF
139 ;
140
141 if($initparams{"Poststop-Hook"}) {
142     print "\t" . join("\n\t",split("\n",$initparams{"Poststop-Hook"}));
143     print "\n";
144 }
145
146 print << 'EOF';
147         return "$RETVAL"
148 }
149
150 #
151 # Function that sends a SIGHUP to the daemon/service
152 #
153 do_reload() {
154         #
155         # If the daemon can reload its configuration without
156         # restarting (for example, when it is sent a SIGHUP),
157         # then implement that here.
158         #
159         start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
160         return 0
161 }
162
163 case "$1" in
164   start)
165         [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
166         do_start
167         case "$?" in
168                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
169                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
170         esac
171         ;;
172   stop)
173         [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
174         do_stop
175         case "$?" in
176                 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
177                 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
178         esac
179         ;;
180   #reload|force-reload)
181         #
182         # If do_reload() is not implemented then leave this commented out
183         # and leave 'force-reload' as an alias for 'restart'.
184         #
185         #log_daemon_msg "Reloading $DESC" "$NAME"
186         #do_reload
187         #log_end_msg $?
188         #;;
189   restart|force-reload)
190         #
191         # If the "reload" option is implemented then remove the
192         # 'force-reload' alias
193         #
194         log_daemon_msg "Restarting $DESC" "$NAME"
195         do_stop
196         case "$?" in
197           0|1)
198                 do_start
199                 case "$?" in
200                         0) log_end_msg 0 ;;
201                         1) log_end_msg 1 ;; # Old process is still running
202                         *) log_end_msg 1 ;; # Failed to start
203                 esac
204                 ;;
205           *)
206                 # Failed to stop
207                 log_end_msg 1
208                 ;;
209         esac
210         ;;
211   *)
212         #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
213         echo "Usage: $SCRIPTNAME {start|stop|restart|force-reload}" >&2
214         exit 3
215         ;;
216 esac
217 EOF
218
219 if ($output) {
220         close STDOUT
221 }